comment ~**********************************************************\
* INT21CHK.COM  is a small TSR utility to log errors returned      *
*  for all services starting with 0Dh and through 6Ch, excluding   *
*  3Eh, the file close service.                                    *
*                                                                  *
* To use this util, type                                           *
*                                                                  *
*   int21chk [n|f|m|v]                                             *
*                                                                  *
* Where n = on, f = off, m = mark, v = verbose                     *
*                                                                  *
* See readme.txt for more info on this utility                     *
*                                                                  *
* Forever Young Software                                           *
* Benjamin David Lunt                                              *
* Copyright 1984-2007                                              *
* All rights reserved                                              *
* Donated to the public for use with the DOS based web browser:    *
*  ARACHNE   http://home.arachne.cz/                               *
* Not supported for any other use...(see readme.txt)               *
*                                                                  *
*  Version 00.90.00                                                *
*  Assebled with: NBASM 00.26.10                                   *
*   http://www.frontiernet.net/~fys/newbasic.html                  *
\*****************************************************************/~

.model tiny
.186
.code

start:     jmp  Install   ; jump to our installation part

newDOSInt: jmp  DoInt     ; skip our data
; don't put anything write here
; don't change posistion of next 6 bytes (must stay write here)
OurID      dw  1234h
OurFlag    db  00h     ; 0 = Off, not 0 = on
MarkCnt    dw  00h     ; marker counter
VerbFlag   db  00h     ; verbose flag
; **************************************************************

olddosint  dw  00h     ; store old interrupt here
           dw  00h     ;  (little-endian)
OrgAX      dw  00h     ; save initail register values before int 21h
OrgBX      dw  00h
OrgCX      dw  00h
OrgDX      dw  00h
OrgSI      dw  00h
OrgDI      dw  00h
OrgDS      dw  00h
OrgES      dw  00h

ServStr    db  'Service:  ',0    ; some strings we print to the file
Filestr    db  '   File:  ',0    ;
Handlestr  db  ' Handle:  ',0    ;
Errorcstr  db  '  Error:  ',0    ;
FuncStr    db  ' Service number called (no error):  ',0
crlf       db  13,10,0           ;
vernums    db  '  version: ',0   ;
MarkStr    db  13,10,10,'**** Marked by user ****  ',0
UtilOn     db  13,10,'Util On ',13,10,0
UtilOff    db  13,10,'Util Off',13,10,0
ourfile    db  'errint21.log',0  ; the file we print our data to

services   dw  offset servxxh  ; 0Dh  ; our services
           dw  10h  ; version num
           dw  offset servxxh  ; 0Eh
           dw  10h  ; version num
           dw  offset serv3Ch  ; 0Fh
           dw  10h  ; version num
           dw  offset serv3Ch  ; 10h
           dw  10h  ; version num
           dw  offset serv3Ch  ; 11h
           dw  10h  ; version num
           dw  offset serv3Ch  ; 12h
           dw  10h  ; version num
           dw  offset serv3Ch  ; 13h
           dw  10h  ; version num
           dw  offset serv3Ch  ; 14h
           dw  10h  ; version num
           dw  offset serv3Ch  ; 15h
           dw  10h  ; version num
           dw  offset serv3Ch  ; 16h
           dw  10h  ; version num
           dw  offset serv3Ch  ; 17h
           dw  10h  ; version num
           dw  offset servxxh  ; 18h
           dw  10h  ; version num
           dw  offset servxxh  ; 19h
           dw  10h  ; version num
           dw  offset servxxh  ; 1Ah
           dw  10h  ; version num
           dw  offset servxxh  ; 1Bh
           dw  10h  ; version num
           dw  offset servxxh  ; 1Ch 
           dw  10h  ; version num
           dw  offset servxxh  ; 1Dh
           dw  10h  ; version num
           dw  offset servxxh  ; 1Eh
           dw  10h  ; version num
           dw  offset servxxh  ; 1Fh
           dw  50h  ; version num
           dw  offset servxxh  ; 20h
           dw  10h  ; version num
           dw  offset serv3Ch  ; 21h
           dw  10h  ; version num
           dw  offset serv3Ch  ; 22h
           dw  10h  ; version num
           dw  offset servxxh  ; 23h
           dw  10h  ; version num
           dw  offset serv3Ch  ; 24h
           dw  10h  ; version num
           dw  offset servxxh  ; 25h
           dw  10h  ; version num
           dw  offset servxxh  ; 26h
           dw  10h  ; version num
           dw  offset serv3Ch  ; 27h
           dw  10h  ; version num
           dw  offset serv3Ch  ; 28h
           dw  10h  ; version num
           dw  offset serv3Ch  ; 29h
           dw  10h  ; version num
           dw  offset servxxh  ; 2Ah
           dw  10h  ; version num
           dw  offset servxxh  ; 2Bh
           dw  10h  ; version num
           dw  offset servxxh  ; 2Ch
           dw  10h  ; version num
           dw  offset servxxh  ; 2Dh
           dw  10h  ; version num
           dw  offset servxxh  ; 2Eh
           dw  10h  ; version num
           dw  offset servxxh  ; 2Fh
           dw  20h  ; version num
           dw  offset servxxh  ; 30h
           dw  20h  ; version num
           dw  offset servxxh  ; 31h
           dw  20h  ; version num
           dw  offset servxxh  ; 32h
           dw  50h  ; version num
           dw  offset servxxh  ; 33h
           dw  20h  ; version num
           dw  offset servxxh  ; 34h
           dw  50h  ; version num
           dw  offset servxxh  ; 35h
           dw  20h  ; version num
           dw  offset servxxh  ; 36h
           dw  20h  ; version num
           dw  offset servxxh  ; 37h
           dw  20h  ; version num
           dw  offset servxxh  ; 38h
           dw  20h  ; version num
           dw  offset serv3Ch  ; 39h
           dw  20h  ; version num
           dw  offset serv3Ch  ; 3Ah
           dw  20h  ; version num
           dw  offset serv3Ch  ; 3Bh
           dw  20h  ; version num
           dw  offset serv3Ch  ; 3Ch
           dw  20h  ; version num
           dw  offset serv3Ch  ; 3Dh
           dw  20h  ; version num
           dw  offset serv3Eh  ; 3Eh
           dw  20h  ; version num
           dw  offset serv3Eh  ; 3Fh
           dw  20h  ; version num
           dw  offset serv3Eh  ; 40h
           dw  20h  ; version num
           dw  offset serv3Ch  ; 41h
           dw  20h  ; version num
           dw  offset serv3Eh  ; 42h
           dw  20h  ; version num
           dw  offset serv3Ch  ; 43h
           dw  20h  ; version num
           dw  offset servxxh  ; 44h
           dw  20h  ; version num
           dw  offset serv3Eh  ; 45h
           dw  20h  ; version num
           dw  offset serv3Eh  ; 46h
           dw  20h  ; version num
           dw  offset servxxh  ; 47h
           dw  20h  ; version num
           dw  offset servxxh  ; 48h
           dw  20h  ; version num
           dw  offset servxxh  ; 49h
           dw  20h  ; version num
           dw  offset servxxh  ; 4Ah
           dw  20h  ; version num
           dw  offset servxxh  ; 4Bh
           dw  20h  ; version num
           dw  offset servxxh  ; 4Ch
           dw  20h  ; version num
           dw  offset servxxh  ; 4Dh
           dw  20h  ; version num
           dw  offset serv3Ch  ; 4Eh
           dw  20h  ; version num
           dw  offset serv3Ch  ; 4Fh
           dw  20h  ; version num
           dw  offset servxxh  ; 50h
           dw  50h  ; version num
           dw  offset servxxh  ; 51h
           dw  50h  ; version num
           dw  offset servxxh  ; 52h
           dw  20h  ; version num
           dw  offset servxxh  ; 53h
           dw  20h  ; version num
           dw  offset servxxh  ; 54h
           dw  20h  ; version num
           dw  offset servxxh  ; 55h
           dw  20h  ; version num
           dw  offset servxxh  ; 56h
           dw  20h  ; version num
           dw  offset servxxh  ; 57h
           dw  20h  ; version num
           dw  offset servxxh  ; 58h
           dw  30h  ; version num
           dw  offset servxxh  ; 59h
           dw  30h  ; version num
           dw  offset serv3Ch  ; 5Ah
           dw  30h  ; version num
           dw  offset serv3Ch  ; 5Bh
           dw  30h  ; version num
           dw  offset servxxh  ; 5Ch
           dw  30h  ; version num
           dw  offset servxxh  ; 5Dh
           dw  50h  ; version num
           dw  offset servxxh  ; 5Eh
           dw  31h  ; version num
           dw  offset servxxh  ; 5Fh
           dw  31h  ; version num
           dw  offset servxxh  ; 60h
           dw  30h  ; version num
           dw  offset servxxh  ; 61h
           dw  30h  ; version num
           dw  offset servxxh  ; 62h
           dw  30h  ; version num
           dw  offset servxxh  ; 63h
           dw  32h  ; version num
           dw  offset servxxh  ; 64h
           dw  32h  ; version num
           dw  offset servxxh  ; 65h
           dw  33h  ; version num
           dw  offset servxxh  ; 66h
           dw  33h  ; version num
           dw  offset servxxh  ; 67h
           dw  33h  ; version num
           dw  offset servxxh  ; 68h
           dw  33h  ; version num
           dw  offset servxxh  ; 69h
           dw  40h  ; version num
           dw  offset servxxh  ; 6Ah
           dw  40h  ; version num
           dw  offset servxxh  ; 6Bh
           dw  40h  ; version num
           dw  offset servxxh  ; 6Ch
           dw  40h  ; version num

tempbuff   dup 256,0                    ; a temp buffer

DoInt:     pushf                        ; save flags
           cmp  byte cs:OurFlag,00h     ; if is off, then skip our stuff
           je   short DoOldInt          ;
           cmp  ah,0Dh                  ; if service is equal to or between
           jb   short DoOldInt          ;  0Dh and 6Ch,
           cmp  ah,6Ch                  ;  then do our code
           jbe  short DoOurInt          ; 
DoOldInt:  popf                         ; restore flags
           jmp  far cs:olddosint        ; else jmp to old interrupt

; our service code
DoOurInt:  mov  cs:OrgAX,ax             ; save all the register values
           mov  cs:OrgBX,bx             ;     for later
           mov  cs:OrgCX,cx             ;
           mov  cs:OrgDX,dx             ;
           mov  cs:OrgSI,si             ;
           mov  cs:OrgDI,di             ;
           mov  cs:OrgDS,ds             ;
           mov  cs:OrgES,es             ;

           cmp  byte cs:VerbFlag,00h    ; do verbose?
           je   short SkipVerb          ;
           pusha
           push ds
           push cs
           pop  ds
           mov  si,offset FuncStr       ; print some text
           call prtstring               ;
           mov  ax,cs:OrgAX             ; print service number
           mov  cx,04                   ; print AX
           call prthex                  ;
           mov  si,offset cs:vernums    ; print version number of this
           call prtstring               ;  service
           mov  bx,ax                   ;
           shr  bx,08h                  ;
           sub  bx,0Dh                  ;
           shl  bx,1                    ;
           shl  bx,1                    ;
           add  bx,offset cs:services   ; get offset of proc
           mov  ax,cs:[bx+2]            ;
           mov  cx,02                   ; print AL
           xchg ah,al
           call prthex                  ;
           mov  si,offset CRLF          ;
           call prtstring               ;
           pop  ds
           popa

SkipVerb:  popf                         ; restore flags
           pushf                        ; create our own discriptor
           push cs                      ;
           push offset Back             ;
           jmp  far cs:olddosint        ; jmp to old interrupt
Back:      pushf                        ; save flags returned by orig int 21h
           jnc  short SkipIt            ; if no error, then skip debug'n it
           pusha                        ; save all general registers
           mov  bx,cs:OrgAX             ;  now lets call our debug code
           shr  bx,08                   ; put bh into bl and clear bh
           cmp  bx,3Eh                  ; skip 'file close' service
           je   short SkipIt1           ;
           sub  bx,000Dh                ;
           shl  bx,2                    ; mul by 4
           add  bx,offset cs:services   ; get offset of proc
           mov  bx,cs:[bx]              ;
           call bx                      ; call it (only bx is modified)
SkipIt1:   popa
SkipIt:    push ax                      ; so that it will ret to the
           push bp                      ; correct place
           mov  bp,sp                   ; 
           mov  ax,[bp-6]               ;
           mov  [bp-8],ax               ;
           mov  ax,[bp-4]               ;
           mov  [bp-6],ax               ;
           pop  bp                      ;
           pop  ax                      ;
           popf                         ; restore flags ret'd by orig 21h
           retf 2                       ;


; non file service or misc file service
servxxh    proc near uses all ds

           push cs                      ; ds = cs
           pop  ds                      ;
           mov  si,offset ServStr       ; print some text
           call prtstring               ;

           mov  ax,cs:OrgAX             ; print service number
           mov  cx,04                   ; print AX
           call prthex                  ;
           mov  si,offset CRLF          ;
           call prtstring               ;

           mov  ax,cs:OrgBX             ; print service number
           mov  cx,04                   ; print AX
           call prthex                  ;
           mov  si,offset CRLF          ;
           call prtstring               ;

           mov  ax,cs:OrgCX             ; print service number
           mov  cx,04                   ; print AX
           call prthex                  ;
           mov  si,offset CRLF          ;
           call prtstring               ;

           mov  ax,cs:OrgDX             ; print service number
           mov  cx,04                   ; print AX
           call prthex                  ;
           mov  si,offset CRLF          ;
           call prtstring               ;
           call prtstring               ;

           ret
servxxh    endp

; 3Ch creates a file.
serv3Ch    proc near uses all ds es
           push ax                      ; save error code

           push cs                      ; ds = cs
           pop  ds                      ;
           mov  si,offset ServStr       ; print some text
           call prtstring               ;

           mov  ax,cs:OrgAX             ; print service number
           mov  cx,04                   ; print AX
           call prthex                  ;

           mov  si,offset CRLF          ;
           call prtstring               ;

           mov  si,offset Filestr       ; print some more text
           call prtstring               ;

           push ds                      ;
           mov  si,cs:OrgDX             ; ds:si = filename
           mov  ds,cs:OrgDS             ;
           call prtstring               ;
           pop  ds                      ;

           mov  si,offset CRLF          ; print some more text
           call prtstring               ;
           mov  si,offset Errorcstr     ;
           call prtstring               ;
           pop  ax                      ; ax = error code
           mov  cx,04                   ; print AX
           call prthex                  ;
           mov  si,offset CRLF          ;
           call prtstring               ;
           call prtstring               ;
           ret                          ;
serv3Ch    endp

; 3Eh close file or device
serv3Eh    proc near  uses all ds es

           push ax                      ; save error code
           push cs                      ; ds = cs
           pop  ds                      ;

           mov  si,offset ServStr       ; print some text
           call prtstring               ;

           mov  ax,OrgAX                ; print service number
           mov  cx,04                   ; print AX
           call prthex                  ;
           mov  si,offset CRLF          ;
           call prtstring               ;

           mov  si,offset Handlestr     ; print some more text
           call prtstring               ;

           mov  ax,OrgBX                ; print original passed handle
           mov  cx,04                   ; print AX
           call prthex                  ;
           mov  si,offset CRLF          ;
           call prtstring               ;

           mov  si,offset Errorcstr     ; print some more text
           call prtstring               ;

           pop  ax                      ; print error code
           mov  cx,04                   ; print AX
           call prthex                  ;
           mov  si,offset CRLF          ;
           call prtstring               ;
           call prtstring               ;
           ret
serv3Eh    endp

prtstring  proc near uses all ds es

           push ds                      ; save ds:si to use later
           push si                      ;
           push cs                      ; es = ds
           pop  es                      ;
           mov  di,offset cs:tempbuff   ; temp buffer
           xor  cx,cx                   ; count chars in string
PS1:       lodsb                        ;
           or   al,al                   ;
           jz   short PSd               ;
           stosb                        ;
           inc  cx                      ;
           jmp  short PS1               ;
PSd:       pop  si                      ; restore si of ds:si
           mov  byte cs:OurFlag,00h     ; temp turn off
           push cx                      ; save count
           push cs                      ; ds = cs
           pop  ds                      ;
           mov  dx,offset cs:ourfile    ; open file
           mov  ax,3D02h                ; read/write
           int  21h                     ; returns handle in bx
           jnc  short PsNoerr
           mov  ah,3Ch                  ; create
           mov  dx,offset cs:ourfile    ;
           mov  cx,32                   ;
           int  21h                     ;
PsNoerr:   mov  bx,ax                   ;
           mov  ax,4202h                ; move to end of file
           xor  cx,cx                   ;
           xor  dx,dx                   ;
           int  21h                     ;
           pop  cx                      ; restore count
           pop  ds                      ; restore ds of ds:si
           mov  ah,40h                  ; write to file
           mov  dx,si                   ;
           int  21h                     ;
           mov  ah,3Eh                  ; close file
           int  21h                     ;

           mov  byte cs:OurFlag,0FFh    ; turn back on

           ret
prtstring  endp

PrtHex     proc near uses all ds es

           push cs                      ; ds = es = cs
           push cs                      ;
           pop  ds                      ;
           pop  es                      ;
           mov  di,offset tempbuff      ; our temp buffer
PLoop:     rol  ax,04                   ;
           push ax                      ;
           and  al,0Fh                  ;
           daa                          ;
           add  al,0F0h                 ;
           adc  al,40h                  ;
           stosb                        ;
           pop  ax                      ;
           loop PLoop                   ;
           mov  ax,2020h                ; spaces
           stosw                        ;

           mov  byte OurFlag,00h        ; temp turn off

           mov  dx,offset ourfile       ; open file
           mov  ax,3D02h                ; read/write
           int  21h                     ; returns handle in bx
           jnc  short PNoErr
           mov  ah,3Ch                  ; create
           mov  dx,offset ourfile       ;
           mov  cx,32                   ;
           int  21h                     ;
PNoErr:    mov  bx,ax                   ; handle
           mov  ax,4202h                ; move to end of file
           xor  cx,cx                   ;
           xor  dx,dx                   ;
           int  21h                     ;
           mov  ah,40h                  ; write to file
           mov  dx,offset tempbuff      ;
           mov  cx,04                   ;
           int  21h                     ;
           mov  ah,3Eh                  ; close file
           int  21h                     ;

           mov  byte OurFlag,0FFh       ; turn back on
           ret
PrtHex     endp


; ******** test for command line and initialize it or quit
Install:   push cs                      ; make sure ds = cs
           pop  ds                      ;

           ; turn it off while in install
           push es                      ; get old interrupt vector (no int 21h)
           xor  ax,ax                   ;
           mov  es,ax                   ;
           mov  bx,es:[0084h]           ;
           mov  ax,es:[0086h]           ;
           mov  es,ax                   ;
           cmp  word es:[bx+3],1234h    ; our ID
           jne  short NotInstal         ;
           mov  byte es:[bx+5],00h      ; set our flag to off
NotInstal: pop  es

           mov  si,80h                  ; get command line
           lodsb                        ;
           or   al,al                   ;
           jnz  short GotCmmnd          ;
Error:     mov  dx,offset StartS        ; print start up text
           mov  ah,09h                  ;
           int  21h                     ;
           mov  dx,offset ErrorS        ;
           int  21h                     ;
Done:      .exit                        ;

GotCmmnd:  lodsb                        ;
           cmp  al,13                   ;  if CR error
           je   short Error             ;
           cmp  al,32                   ;  skip all spaces
           je   short GotCmmnd          ;
           cmp  al,'v'                  ;  verbose on
           je   short Verbit            ;
           cmp  al,'m'                  ;  mark the file
           je   short Markit            ;
           cmp  al,'n'                  ;  if 'n' then on
           je   short DoOn              ;
           cmp  al,'f'                  ;  if 'f' then off
           jne  short GotCmmnd          ;

; *** check and set off flag
           mov  ax,3521h                ; get old interrupt vector
           int  21h                     ;  returns in es:bx
           cmp  word es:[bx+3],1234h    ; our ID
           jne  short Error             ;
           mov  byte es:[bx+5],00h      ; set our flag to off
           mov  dx,offset DoOffS        ;  print test
           mov  ah,09h                  ;
           int  21h                     ;
           mov  si,offset UtilOff       ; mark file with 'off'
           call prtstring               ;
           jmp  short Done              ;

Verbit:    xor  ax,ax                   ; get old interrupt vector (no int 21h)
           mov  es,ax                   ;
           mov  bx,es:[0084h]           ;
           mov  ax,es:[0086h]           ;
           mov  es,ax                   ;
           cmp  word,es:[bx+3],1234h
           jne  short Done
           not  byte,es:[bx+8]          ; change our verbos flag
           mov  byte,es:[bx+5],0FFh     ; turn it back on
           jmp  short Done

; *** mark this place in the file
Markit:    xor  ax,ax                   ; get old interrupt vector (no int 21h)
           mov  es,ax                   ;
           mov  bx,es:[0084h]           ;
           mov  ax,es:[0086h]           ;
           mov  es,ax                   ;
           cmp  word,es:[bx+3],1234h
           jne  short Done
           inc  word,es:[bx+6]          ; inc our marker count
           mov  ax,es:[bx+6]            ; get our marker count
           mov  si,offset MarkStr       ;
           call prtstring               ;
           call prthex                  ;
           mov  si,offset CRLF          ;
           call prtstring               ; (turns it back on for us)
           jmp  Done

; *** check and set on flag
DoOn:      mov  ax,3521h                ; get old interrupt vector
           int  21h                     ;  returns in es:bx
           cmp  word es:[bx+3],1234h    ; Our ID
           jne  short NotOn             ;
           mov  byte es:[bx+5],0FFh     ; set our flag to on
           mov  dx,offset DoOnS         ; print text
           mov  ah,09h                  ;
           int  21h                     ;
           mov  si,offset UtilOn        ; mark file with 'on'
           call prtstring               ;
           jmp  Done                    ;

NotOn:     mov  dx,offset StartS        ; print start up text
           mov  ah,09h                  ;
           int  21h                     ;

           mov  byte cs:OurFlag,0FFh    ; set on flag
           mov  cs:[olddosint],bx       ; and save in static data area
           mov  cs:[olddosint+2],es     ;

           mov  es,cs:[002Ch]           ; free evironment block
           mov  ah,49h                  ;
           int  21h                     ;

           mov  dx,offset cs:newdosint  ; set new interrupt vector
           mov  ax,2521h                ;
           int  21h                     ;

           mov  si,offset UtilOn        ; mark file with 'on'
           call prtstring               ;

           mov  dx,offset cs:Install    ; get paragraphs needed
           sub  dx,offset cs:Start      ;
           shr  dx,04                   ;
           add  dx,17                   ; add 16 paras for PSP + 1 extra
           mov  ax,3100h                ; termination and stay resident
           int  21h                     ;

; data that can be overwritten
StartS     db  13,10,'A TSR to log errors for INT 21h calls. (v00.90.00)'
           db  13,10,36
ErrorS     db  13,10,'Command line argument required:'
           db  13,10," f   - stop debug'n (off)"
           db  13,10,' m   - mark this place in the file'
           db  13,10,' n   - install (or on if installed)'
           db  13,10,' v   - verbose (again for off)'
           db  13,10,'   The first applicable command used, rest is ignored.'
           db  13,10,36
DoOffS     db  13,10,'Util is Off'
           db  13,10,36
DoOnS      db  13,10,'Util is On'
           db  13,10,36
.end
